(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex_index.mli,v 1.4 2013-07-02 16:58:46 fclement Exp $*)

(** {3 The type of index indices} *)

type 'a element = 'a Uindex.t;;
type 'a index = 'a element Uindex.t;;

val to_index : Unatural.t -> 'a index;;
val of_index : 'a index -> Unatural.t;;

val of_natural : Unatural.t -> 'a index;;
val to_natural : 'a index -> Unatural.t;;

val of_int : int -> 'a index;;
val to_int : 'a index -> int;;

val _0_ : 'a index;;
val _1_ : 'a index;;

val succ : 'a index -> 'a index;;
val pred : 'a index -> 'a index;;
