(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprintc.bin generated code *)

let print_arrow_number ppf = function
  | u_a -> Udynamic_graph_print.print_arrow_number ppf u_a
;;

let print_delayed_image pp_a ppf = function
  | Udelayed_dgraph.Not_yet_computed ->
    Format.fprintf ppf "%s" "Not_yet_computed"
  | Udelayed_dgraph.Image a ->
    Format.fprintf ppf "@[<1>%s@ " "Image"; pp_a ppf a;
    Format.fprintf ppf "%,@]"
;;

let print_delayed_arrow pp_a pp_b ppf = function
  | a_b_d_u_a ->
    Udynamic_graph_print.print_arrow pp_a (print_delayed_image pp_b) ppf
     a_b_d_u_a
;;

let print_t pp_a pp_b pp_c ppf = function
  | {
      Udelayed_dgraph.f = f_c_f_a_f_a_b;
      Udelayed_dgraph.graph = a_b_d_u_t;
      Udelayed_dgraph.to_do = a_l;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>f =@ ";
    Lib_print.print_fun pp_c
     (Lib_print.print_fun print_arrow_number (Lib_print.print_fun pp_a pp_b))
     ppf f_c_f_a_f_a_b;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>graph =@ ";
    Udynamic_graph_print.print_t pp_a (print_delayed_image pp_b) ppf
     a_b_d_u_t;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>to_do =@ ";
    Lib_print.print_List print_arrow_number ppf a_l;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of ocamlprintc.bin generated code *)
