type index = Unatural.t
;;
type index_set_1d =
   | Is_empty
   | Is_range of Natural_range.t
   (* begin
        rule Is_range ({ Natural_range.left_bound = l; right_bound = r })
          when l = r ->
          Is_empty
      end *)
   | Is_extensional of index array
   (* begin
        rule Is_extensional ([|  |]) -> Is_empty
      end *)
   | Is_union of index_set_1d * index_set_1d
   (* begin
        associative
        commutative
        neutral (Is_empty)
        idempotent
      end *)
;;
let rec is_range moca_x =
  match moca_x with
  | { Natural_range.left_bound = l; right_bound = r } when (l = r) ->
    is_empty
  | _ -> Is_range moca_x

and is_empty = Is_empty

and is_extensional moca_x =
  match moca_x with
  | [|  |] -> is_empty
  | _ -> Is_extensional moca_x

and compare_is_union = Pervasives.compare

and is_union moca_z =
  match moca_z with
  | (moca_x, Is_empty) -> moca_x
  | (Is_empty, moca_x) -> moca_x
  | (moca_x, (Is_union (moca_y, _) as moca_z))
      when
      compare_is_union moca_x moca_y = 0 ->
    moca_z
  | ((Is_union (_, moca_x) as moca_z), moca_y)
      when
      compare_is_union moca_x moca_y = 0 ->
    moca_z
  | (moca_x, moca_y) when compare_is_union moca_x moca_y = 0 -> moca_x
  | (Is_union (moca_x, moca_y), moca_z) ->
    is_union (moca_x, (is_union (moca_y, moca_z)))
  | (moca_x, Is_union (moca_y, moca_z)) ->
    if compare_is_union moca_x moca_y > 0
    then is_union (moca_y, (is_union (moca_x, moca_z)))
    else Is_union (moca_x, (Is_union (moca_y, moca_z)))
  | (moca_x, moca_y) when compare_is_union moca_x moca_y > 0 ->
    is_union (moca_y, moca_x)
  | (moca_x, moca_y) -> Is_union (moca_x, moca_y)
;;

external eq_index_set_1d : index_set_1d -> index_set_1d -> bool = "%equal"
;;

type t = index_set_1d
;;
