let compile m =
  match
    Sys.command (Printf.sprintf
      "ocamlc -I ../../tarballs/work/ulib/src/ -c %s" m
    ) with
  | 0 -> ()
  | n -> exit n
;;

let compile_mlm mlm =
  match
    Sys.command (Printf.sprintf
      "mocac %s" mlm
    ) with
  | 0 -> ()
  | n -> exit n
;;

compile_mlm "index_set_1d.mlm";;

List.iter compile [
  "natural_range.mli";
  "natural_range.ml";
  "index_set_1d.mli";
  "index_set_1d.ml";
  "index_set_1d_union.mli";
  "index_set_1d_union.ml";
]
;;

#load "unatural_types.cmo";;
#load "unatural.cmo";;
#load "natural_range.cmo";;
#load "index_set_1d.cmo";;
#load "index_set_1d_union.cmo";;

open Unatural;;
open Natural_range;;
open Index_set_1d;;
open Index_set_1d_union;;

(* Tests union is_range/is_range *)
let s1 = is_range (natural_range Unatural._3_ Unatural._7_);;

union (s1, s1) = s1;;

let s2 = is_range (natural_range Unatural._1_ Unatural._5_);;
let s3 = is_range (natural_range Unatural._1_ Unatural._7_);;
let s4 = is_range (natural_range Unatural._5_ Unatural._9_);;
let s5 = is_range (natural_range Unatural._1_ Unatural._9_);;
let s6 = is_range (natural_range Unatural._3_ Unatural._9_);;

union (s1, s2) = s3;;
union (s3, s1) = s3;;
union (s1, s4) = s6;;

let s7 = is_range (natural_range Unatural._1_ Unatural._7_);;
union (s7, s5) = s5;;

let s8 = is_range (natural_range Unatural._7_ Unatural._9_);;
union (s1, s8) = s6;;

let s9 = is_range (natural_range Unatural._1_ Unatural._7_);;
union (s2, s8) = is_union (s2, s8);;

let s10 = union (s2, s8);;
union (s1, s10) = s5;;

(* Tests union is_range/is_extensional *)
